var window = window || global;
const libObject = {};
var define = define || function define(name, argsNames, calle) {
  calle.apply(null, argsNames.map(() => libObject));
  Object.keys(libObject).forEach(key => {
    if (key !== '__esModule') {
      window[key] = libObject[key];
    }
  });
};

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define("environment.service", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var EnvironmentService = (function () {
        function EnvironmentService() {
            this.SOFTWARE_IDENTIFIER = 'catch-by-respawn-camping';
            this.basicAuth = null;
            this.atlassianJiraServer = null;
            this.defaultProjectKey = '';
            this.maxCommentsInIssue = 30;
            this.bugTypeName = 'Bug';
            this.initialTransactionId = null;
            this.jiraVersion = 2;
            this.aditionalInformation = '';
            this.waitTimeConfig = {
                betweenEachInteractionOnTheSameIssue: 7200000,
                lowNetworkWhileUserIsActive: 7200000,
            };
            this.stopInteractWhen = {
                maximumAmountOfIssuesReached: 30
            };
            this.updateJiraHistory = false;
            if (!EnvironmentService.instance) {
                EnvironmentService.instance = this;
            }
            return EnvironmentService.instance;
        }
        return EnvironmentService;
    }());
    EnvironmentService.instance = null;
    exports.EnvironmentService = EnvironmentService;
});
define("error-handler/error-normalized.model", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("error-handler/custom-error-nomalizar.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("error-handler/common-error.normalizer", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var CommonErrorNormalizer = (function () {
        function CommonErrorNormalizer() {
            this.name = 'error-event';
        }
        CommonErrorNormalizer.prototype.typeCheck = function (possibleErrorEvent) {
            if (possibleErrorEvent instanceof ErrorEvent) {
                return true;
            }
            return false;
        };
        CommonErrorNormalizer.prototype.normalize = function (errorEvent) {
            var id = '';
            var content = '';
            var title = '';
            var error = null;
            var labels = [];
            if (errorEvent.error && errorEvent.error.rejection) {
                id = 'runtime-in-promise';
                title = 'Promise broken';
                content = 'The error was caught in an unhandled promise.\n';
                error = errorEvent.error.rejection;
            }
            else if (errorEvent.error) {
                id = 'runtime-thown-error';
                title = 'Error thrown';
                content = 'The error was thrown in the application body.\n';
                error = errorEvent.error;
            }
            else {
                id = 'script-error';
                title = 'Script error';
                content = errorEvent.message;
            }
            if (error) {
                content += "Error Type: " + error.name + ".";
                labels.push(id + "-" + error.name);
                id += error.message;
                title += error.message;
                content += "\n      \n        Message: " + error.message + ".\n        Stack: " + error.stack + ".";
            }
            else {
                labels.push(id + "-" + errorEvent.message);
            }
            return {
                id: id, title: title, content: content, labels: labels
            };
        };
        return CommonErrorNormalizer;
    }());
    exports.CommonErrorNormalizer = CommonErrorNormalizer;
});
define("jira/jira-comment-issue-request.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("jira/jira-create-issue-request.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("http/http-method.const", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.HttpMethod = {
        POST: 'POST',
        GET: 'GET',
        PUT: 'PUT',
        DELETE: 'DELETE'
    };
});
define("common-types/ecma-value.type", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("common-types/ecma-model.type", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("common-types/ecma-json-object.type", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("util/object.util", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ObjectUtil = (function () {
        function ObjectUtil() {
            if (!ObjectUtil.instance) {
                ObjectUtil.instance = this;
            }
            return ObjectUtil.instance;
        }
        ObjectUtil.prototype.assign = function (obj1, obj2) {
            var obj3 = {};
            Object.keys(obj1).forEach(function (key) { obj3[key] = obj1[key]; });
            Object.keys(obj2).forEach(function (key) { obj3[key] = obj2[key]; });
            return obj3;
        };
        ObjectUtil.prototype.clone = function (obj) {
            return JSON.parse(JSON.stringify(obj));
        };
        return ObjectUtil;
    }());
    ObjectUtil.instance = null;
    exports.ObjectUtil = ObjectUtil;
});
define("http/http-request-options.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("http/http.service", ["require", "exports", "util/object.util"], function (require, exports, object_util_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var HttpService = (function () {
        function HttpService() {
            this.objectUtil = new object_util_1.ObjectUtil();
            this.defaultHeaders = {
                'Content-Type': 'application/json'
            };
            if (!HttpService.instance) {
                HttpService.instance = this;
            }
            return HttpService.instance;
        }
        HttpService.prototype.request = function (options) {
            var xhr = new HttpService.XMLHttpRequest();
            xhr.open(options.method, options.server);
            this.setRequestHeaders(xhr, options.headers || {});
            var promise = this.listenRequest(xhr);
            if (options.payload) {
                xhr.send(JSON.stringify(options.payload));
            }
            else {
                xhr.send();
            }
            return promise;
        };
        HttpService.prototype.listenRequest = function (xhr) {
            var statusCodeSimplification = 100;
            var statusCodeSuccessLevel = 2;
            var httpReadyStateDone = 4;
            var httpNoContentStatus = 204;
            return new Promise(function (resolve, reject) {
                xhr.onreadystatechange = function () {
                    if (xhr.readyState === httpReadyStateDone) {
                        if (Math.floor(xhr.status / statusCodeSimplification) === statusCodeSuccessLevel) {
                            try {
                                var responseData = xhr.status === httpNoContentStatus ? null : JSON.parse(xhr.responseText);
                                resolve(responseData);
                            }
                            catch (e) {
                                reject(e);
                            }
                        }
                        else {
                            reject(xhr);
                        }
                    }
                };
            });
        };
        HttpService.prototype.setRequestHeaders = function (xhr, headers) {
            var newHeaders = this.objectUtil.assign(this.defaultHeaders, headers);
            Object.keys(newHeaders).forEach(function (key) {
                xhr.setRequestHeader(key, String(newHeaders[key]));
            });
        };
        return HttpService;
    }());
    HttpService.instance = null;
    HttpService.XMLHttpRequest = XMLHttpRequest;
    exports.HttpService = HttpService;
});
define("jira/jira-comment-issue-response.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("jira/jira-create-issue-response.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("jira/jira-get-issue-response.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("jira/jira-get-issue-transaction-response.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("jira/jira-search-issue-response.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("jira/jira-integration.api", ["require", "exports", "http/http-method.const", "environment.service", "http/http.service"], function (require, exports, http_method_const_1, environment_service_1, http_service_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var JiraIntegrationApi = (function () {
        function JiraIntegrationApi() {
            this.http = new http_service_1.HttpService();
            this.environment = new environment_service_1.EnvironmentService();
            if (!JiraIntegrationApi.instance) {
                JiraIntegrationApi.instance = this;
            }
            return JiraIntegrationApi.instance;
        }
        JiraIntegrationApi.prototype.createIssue = function (createIssue) {
            return this.http.request({
                method: http_method_const_1.HttpMethod.POST,
                server: this.mountPath('issue') + "?updateHistory=" + String(this.environment.updateJiraHistory),
                headers: this.generateAuthHeader(),
                payload: createIssue
            });
        };
        JiraIntegrationApi.prototype.findIssueByLabel = function (labels, maxResults) {
            var labelsCondition = labels.map(function (label) { return 'labels = ' + label; }).join(' AND ');
            var configuredMaxResults = maxResults ? "&maxResults=" + maxResults : '';
            var jql = "project = " + this.environment.defaultProjectKey + " AND issuetype = " + this.environment.bugTypeName + " AND " + labelsCondition;
            var queryString = "?currentProjectId=" + this.environment.defaultProjectKey + "&jql=" + jql + "&fields=summary,issuetype" + configuredMaxResults;
            return this.http.request({
                method: http_method_const_1.HttpMethod.GET,
                server: this.mountPath("search" + queryString),
                headers: this.generateAuthHeader()
            });
        };
        JiraIntegrationApi.prototype.commentOnIssue = function (issueKey, comment) {
            return this.http.request({
                method: http_method_const_1.HttpMethod.POST,
                server: this.mountPath("issue/" + issueKey + "/comment"),
                headers: this.generateAuthHeader(),
                payload: comment
            });
        };
        JiraIntegrationApi.prototype.getIssue = function (issueKey) {
            return this.http.request({
                method: http_method_const_1.HttpMethod.GET,
                server: this.mountPath("issue/" + issueKey + "?fields=comment"),
                headers: this.generateAuthHeader()
            });
        };
        JiraIntegrationApi.prototype.getIssueTransitionHistory = function (issueKey) {
            return this.http.request({
                method: http_method_const_1.HttpMethod.GET,
                server: this.mountPath("issue/" + issueKey + "/transitions"),
                headers: this.generateAuthHeader()
            });
        };
        JiraIntegrationApi.prototype.setIssueTransaction = function (issueKey, transactId) {
            return this.http.request({
                method: http_method_const_1.HttpMethod.POST,
                server: this.mountPath("issue/" + issueKey + "/transitions"),
                headers: this.generateAuthHeader(),
                payload: {
                    transition: { id: transactId }
                }
            });
        };
        JiraIntegrationApi.prototype.mountPath = function (endpoint) {
            return this.environment.atlassianJiraServer + "rest/api/" + this.environment.jiraVersion + "/" + endpoint;
        };
        JiraIntegrationApi.prototype.generateAuthHeader = function () {
            var headers = {};
            if (this.environment.basicAuth) {
                headers['Authorization'] = "Basic " + this.environment.basicAuth;
            }
            return headers;
        };
        return JiraIntegrationApi;
    }());
    JiraIntegrationApi.instance = null;
    exports.JiraIntegrationApi = JiraIntegrationApi;
});
define("util/string.util", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var StringUtil = (function () {
        function StringUtil() {
            this.MAX_LABEL_SIZE = 45;
            this.NOT_ALPHANUMERIC_CHAR = /[^a-z0-9\s\-]/ig;
            this.ACCENT_A = /[áàãâ]/ig;
            this.ACCENT_E = /[éèê]/ig;
            this.ACCENT_I = /[íì]/ig;
            this.ACCENT_O = /[óõòô]/ig;
            this.ACCENT_U = /[úùü]/ig;
            if (!StringUtil.instance) {
                StringUtil.instance = this;
            }
            return StringUtil.instance;
        }
        StringUtil.prototype.labelfy = function (label) {
            return label
                .trim()
                .replace(this.ACCENT_A, 'a')
                .replace(this.ACCENT_E, 'e')
                .replace(this.ACCENT_I, 'i')
                .replace(this.ACCENT_O, 'o')
                .replace(this.ACCENT_U, 'u')
                .replace(this.NOT_ALPHANUMERIC_CHAR, '')
                .replace(/\s+/g, '-')
                .replace(/\[-]+/g, '-')
                .toLowerCase()
                .substr(0, this.MAX_LABEL_SIZE);
        };
        return StringUtil;
    }());
    StringUtil.instance = null;
    exports.StringUtil = StringUtil;
});
define("respawn-camping/error-to-register.interface", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("respawn-camping/interaction-controller.service", ["require", "exports", "jira/jira-integration.api", "environment.service"], function (require, exports, jira_integration_api_1, environment_service_2) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var InteractionControllerService = (function () {
        function InteractionControllerService() {
            this.environment = new environment_service_2.EnvironmentService();
            this.jiraApi = new jira_integration_api_1.JiraIntegrationApi();
            if (!InteractionControllerService.instance) {
                InteractionControllerService.instance = this;
            }
            return InteractionControllerService.instance;
        }
        InteractionControllerService.prototype.canInteract = function () {
            return __awaiter(this, void 0, void 0, function () {
                var issues, maximumAmountOfIssuesReached, maxOfIssuesReached;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.jiraApi.findIssueByLabel([this.environment.SOFTWARE_IDENTIFIER])];
                        case 1:
                            issues = _a.sent();
                            maximumAmountOfIssuesReached = this.environment.stopInteractWhen.maximumAmountOfIssuesReached;
                            if (maximumAmountOfIssuesReached !== false) {
                                maxOfIssuesReached = issues.total >= this.environment.stopInteractWhen.maximumAmountOfIssuesReached;
                                if (maxOfIssuesReached) {
                                    return [2 /*return*/, false];
                                }
                            }
                            return [2 /*return*/, true];
                    }
                });
            });
        };
        InteractionControllerService.prototype.shouldComment = function (issue) {
            var comment = issue.fields.comment.comments.pop();
            if (comment) {
                var configuredEarly = new Date().getTime() - this.environment.waitTimeConfig.betweenEachInteractionOnTheSameIssue;
                var isTooEarlyToComment = new Date(comment.updated) > new Date(configuredEarly);
                if (isTooEarlyToComment) {
                    return false;
                }
            }
            if (issue.fields.comment.total <= this.environment.maxCommentsInIssue) {
                return true;
            }
            return false;
        };
        return InteractionControllerService;
    }());
    InteractionControllerService.instance = null;
    exports.InteractionControllerService = InteractionControllerService;
});
define("respawn-camping/respawn-camping.service", ["require", "exports", "environment.service", "jira/jira-integration.api", "util/object.util", "util/string.util", "respawn-camping/interaction-controller.service"], function (require, exports, environment_service_3, jira_integration_api_2, object_util_2, string_util_1, interaction_controller_service_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var RespawnCampingService = (function () {
        function RespawnCampingService() {
            this.objectUtil = new object_util_2.ObjectUtil();
            this.stringUtil = new string_util_1.StringUtil();
            this.jiraApi = new jira_integration_api_2.JiraIntegrationApi();
            this.environment = new environment_service_3.EnvironmentService();
            this.interactionController = new interaction_controller_service_1.InteractionControllerService();
            if (!RespawnCampingService.instance) {
                RespawnCampingService.instance = this;
            }
            return RespawnCampingService.instance;
        }
        RespawnCampingService.prototype.registerRespawnedBug = function (normalizerName, error) {
            return __awaiter(this, void 0, void 0, function () {
                var canInteract, registrable, resultSet, issueKey, issueResultSet, firstStateId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.interactionController.canInteract()];
                        case 1:
                            canInteract = _a.sent();
                            if (!canInteract) {
                                return [2 /*return*/, Promise.resolve()];
                            }
                            registrable = this.createRegistrableError(normalizerName, error);
                            return [4 /*yield*/, this.jiraApi.findIssueByLabel([this.environment.SOFTWARE_IDENTIFIER, registrable.error.id], 1)];
                        case 2:
                            resultSet = _a.sent();
                            issueKey = this.getIssueKeyFromSearch(resultSet);
                            if (!issueKey) return [3 /*break*/, 8];
                            return [4 /*yield*/, this.jiraApi.getIssue(issueKey)];
                        case 3:
                            issueResultSet = _a.sent();
                            return [4 /*yield*/, this.getFirstTransactionId(issueKey)];
                        case 4:
                            firstStateId = _a.sent();
                            if (!firstStateId) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, this.jiraApi.setIssueTransaction(issueKey, firstStateId)];
                        case 5:
                            _a.sent();
                            if (!this.interactionController.shouldComment(issueResultSet)) return [3 /*break*/, 7];
                            return [4 /*yield*/, this.jiraApi.commentOnIssue(issueKey, this.generateCommentResultSet(registrable))];
                        case 6:
                            _a.sent();
                            return [2 /*return*/, Promise.resolve()];
                        case 7: return [2 /*return*/, Promise.resolve()];
                        case 8: return [4 /*yield*/, this.jiraApi.createIssue(this.generateIssueResultSet(registrable))];
                        case 9:
                            _a.sent();
                            return [2 /*return*/, Promise.resolve()];
                    }
                });
            });
        };
        RespawnCampingService.prototype.getFirstTransactionId = function (issueKey) {
            return __awaiter(this, void 0, void 0, function () {
                var firstStateId, issueTransactions, firstIssueState;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firstStateId = this.environment.initialTransactionId;
                            if (!!firstStateId) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.jiraApi.getIssueTransitionHistory(issueKey)];
                        case 1:
                            issueTransactions = _a.sent();
                            firstIssueState = issueTransactions.transitions.shift();
                            firstStateId = firstIssueState && firstIssueState.id || null;
                            return [2 /*return*/, Promise.resolve(firstStateId)];
                        case 2: return [2 /*return*/, Promise.resolve(firstStateId)];
                    }
                });
            });
        };
        RespawnCampingService.prototype.generateCommentResultSet = function (toRegister) {
            return {
                body: toRegister.error.title + "\n\n" + toRegister.aditionalInformation
            };
        };
        RespawnCampingService.prototype.generateIssueResultSet = function (toRegister) {
            return {
                fields: {
                    summary: toRegister.error.title,
                    issuetype: {
                        name: this.environment.bugTypeName || 'Bug'
                    },
                    description: toRegister.aditionalInformation,
                    labels: toRegister.error.labels,
                    project: {
                        key: this.environment.defaultProjectKey
                    }
                }
            };
        };
        RespawnCampingService.prototype.getIssueKeyFromSearch = function (resultSet) {
            return resultSet.issues && resultSet.issues[0] && resultSet.issues[0].key || null;
        };
        RespawnCampingService.prototype.createRegistrableError = function (normalizerName, error) {
            var _this = this;
            var clonedError = this.objectUtil.clone(error);
            clonedError.id = this.stringUtil.labelfy("id-" + normalizerName + "-" + clonedError.id);
            clonedError.labels.push(this.environment.SOFTWARE_IDENTIFIER);
            clonedError.labels = clonedError.labels.map(function (label) { return _this.stringUtil.labelfy(label); });
            clonedError.labels.push(clonedError.id);
            var aditionalInformation = '' +
                "Environment Information:\n" +
                ("User Agent: " + navigator.userAgent + ";\n") +
                ("Browser size: (" + innerWidth + " x " + innerHeight + ");\n") +
                ("Url: " + location.href + ";\n") +
                ("Time: " + this.getFormattedCurrentDate() + ";\n") +
                '\n' +
                (this.environment.aditionalInformation + "\n") +
                '\n' +
                (error.content + "\n");
            return {
                originName: normalizerName,
                aditionalInformation: aditionalInformation,
                error: clonedError
            };
        };
        RespawnCampingService.prototype.getFormattedCurrentDate = function () {
            var date = new Date();
            var decimalBase = 10;
            var d = date.getDate();
            d = d < decimalBase ? '0' + d : d;
            var m = date.getMonth() + 1;
            m = m < decimalBase ? '0' + m : m;
            var Y = date.getFullYear();
            var H = date.getHours();
            H = H < decimalBase ? '0' + H : H;
            var i = date.getMinutes();
            i = i < decimalBase ? '0' + i : i;
            var s = date.getSeconds();
            s = s < decimalBase ? '0' + s : s;
            return "[" + d + "/" + m + "/" + Y + " " + H + ":" + i + ":" + s + "]";
        };
        return RespawnCampingService;
    }());
    RespawnCampingService.instance = null;
    exports.RespawnCampingService = RespawnCampingService;
});
define("error-handler/normalizer-clazz.type", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("error-handler/error-handler.service", ["require", "exports", "respawn-camping/respawn-camping.service"], function (require, exports, respawn_camping_service_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ErrorHandlingService = (function () {
        function ErrorHandlingService() {
            this.camper = new respawn_camping_service_1.RespawnCampingService();
            this.errorNormalizer = {};
            if (!ErrorHandlingService.instance) {
                ErrorHandlingService.instance = this;
            }
            return ErrorHandlingService.instance;
        }
        ErrorHandlingService.prototype.declareCustomErrorNormalizer = function (clazzes) {
            var _this = this;
            clazzes.forEach(function (clazz) {
                var normalizer = new clazz();
                _this.errorNormalizer[normalizer.name] = normalizer;
            });
        };
        ErrorHandlingService.prototype.identifyNormalizer = function (thrown) {
            var _this = this;
            var nameFound = Object.keys(this.errorNormalizer).find(function (name) { return _this.errorNormalizer[name].typeCheck(thrown); }) || null;
            return this.errorNormalizer[nameFound || ''] || null;
        };
        ErrorHandlingService.prototype.launch = function (thrownThing) {
            var normalizer = this.identifyNormalizer(thrownThing);
            if (normalizer) {
                var normalized = normalizer.normalize(thrownThing);
                if (normalized) {
                    this.camper.registerRespawnedBug(normalizer.name, normalized);
                }
            }
        };
        return ErrorHandlingService;
    }());
    ErrorHandlingService.instance = null;
    exports.ErrorHandlingService = ErrorHandlingService;
});
define("respawn-camping/handler.builder", ["require", "exports", "environment.service", "error-handler/error-handler.service"], function (require, exports, environment_service_4, error_handler_service_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var HandlerBuilder = (function () {
        function HandlerBuilder() {
            this.enviroment = new environment_service_4.EnvironmentService();
            this.errorHandling = new error_handler_service_1.ErrorHandlingService();
            if (!HandlerBuilder.instance) {
                HandlerBuilder.instance = this;
            }
            return HandlerBuilder.instance;
        }
        HandlerBuilder.prototype.declareCustomErrorNormalizer = function (clazzes) {
            this.errorHandling.declareCustomErrorNormalizer(clazzes);
            return this;
        };
        HandlerBuilder.prototype.setAtlassianJiraServer = function (server) {
            this.enviroment.atlassianJiraServer = server;
            return this;
        };
        HandlerBuilder.prototype.setDefaultProjectKey = function (projectKey) {
            this.enviroment.defaultProjectKey = projectKey;
            return this;
        };
        HandlerBuilder.prototype.setBugTypeName = function (bugTypeName) {
            this.enviroment.bugTypeName = bugTypeName;
            return this;
        };
        HandlerBuilder.prototype.setInitialTransactionId = function (initialTransactionId) {
            this.enviroment.initialTransactionId = initialTransactionId;
            return this;
        };
        HandlerBuilder.prototype.setMaximumAmountOfIssues = function (maxAmount) {
            this.enviroment.stopInteractWhen.maximumAmountOfIssuesReached = maxAmount;
            return this;
        };
        HandlerBuilder.prototype.basicAuth = function (basicAuth) {
            this.enviroment.basicAuth = basicAuth;
            return this;
        };
        HandlerBuilder.prototype.updateJiraHistoryOnIssueCreate = function () {
            this.enviroment.updateJiraHistory = true;
            return this;
        };
        HandlerBuilder.prototype.build = function () {
            return new error_handler_service_1.ErrorHandlingService();
        };
        return HandlerBuilder;
    }());
    HandlerBuilder.instance = null;
    exports.HandlerBuilder = HandlerBuilder;
});
define("index", ["require", "exports", "error-handler/common-error.normalizer", "error-handler/error-handler.service", "respawn-camping/handler.builder", "respawn-camping/respawn-camping.service"], function (require, exports, common_error_normalizer_1, error_handler_service_2, handler_builder_1, respawn_camping_service_2) {
    "use strict";
    function __export(m) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }
    Object.defineProperty(exports, "__esModule", { value: true });
    __export(common_error_normalizer_1);
    __export(error_handler_service_2);
    __export(handler_builder_1);
    __export(respawn_camping_service_2);
});
define("common-types/clazz.type", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
