import { JiraCommentIssueRequest } from './jira-comment-issue-request.interface';
import { JiraCommentIssueResponse } from './jira-comment-issue-response.interface';
import { JiraCreateIssueRequest } from './jira-create-issue-request.interface';
import { JiraCreateIssueResponse } from './jira-create-issue-response.interface';
import { JiraGetIssueResponse } from './jira-get-issue-response.interface';
import { JiraGetIssueTransactionResponse } from './jira-get-issue-transaction-response.interface';
import { JiraSearchIssueResponse } from './jira-search-issue-response.interface';
export declare class JiraIntegrationApi {
    private static instance;
    private http;
    private environment;
    constructor();
    createIssue(createIssue: JiraCreateIssueRequest): Promise<JiraCreateIssueResponse>;
    findIssueByLabel(labels: string[], maxResults?: number): Promise<JiraSearchIssueResponse>;
    commentOnIssue(issueKey: string, comment: JiraCommentIssueRequest): Promise<JiraCommentIssueResponse>;
    getIssue(issueKey: string): Promise<JiraGetIssueResponse>;
    getIssueTransitionHistory(issueKey: string): Promise<JiraGetIssueTransactionResponse>;
    setIssueTransaction(issueKey: string, transactId: string): Promise<void>;
    private mountPath(endpoint);
    private generateAuthHeader();
}
