"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var jira_integration_api_1 = require("../jira/jira-integration.api");
var environment_service_1 = require("./../environment.service");
var InteractionControllerService = (function () {
    function InteractionControllerService() {
        this.environment = new environment_service_1.EnvironmentService();
        this.jiraApi = new jira_integration_api_1.JiraIntegrationApi();
        if (!InteractionControllerService.instance) {
            InteractionControllerService.instance = this;
        }
        return InteractionControllerService.instance;
    }
    InteractionControllerService.prototype.canInteract = function () {
        return __awaiter(this, void 0, void 0, function () {
            var issues, maximumAmountOfIssuesReached, maxOfIssuesReached;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.jiraApi.findIssueByLabel([this.environment.SOFTWARE_IDENTIFIER])];
                    case 1:
                        issues = _a.sent();
                        maximumAmountOfIssuesReached = this.environment.stopInteractWhen.maximumAmountOfIssuesReached;
                        if (maximumAmountOfIssuesReached !== false) {
                            maxOfIssuesReached = issues.total >= this.environment.stopInteractWhen.maximumAmountOfIssuesReached;
                            if (maxOfIssuesReached) {
                                return [2 /*return*/, false];
                            }
                        }
                        return [2 /*return*/, true];
                }
            });
        });
    };
    InteractionControllerService.prototype.shouldComment = function (issue) {
        var comment = issue.fields.comment.comments.pop();
        if (comment) {
            var configuredEarly = new Date().getTime() - this.environment.waitTimeConfig.betweenEachInteractionOnTheSameIssue;
            var isTooEarlyToComment = new Date(comment.updated) > new Date(configuredEarly);
            if (isTooEarlyToComment) {
                return false;
            }
        }
        if (issue.fields.comment.total <= this.environment.maxCommentsInIssue) {
            return true;
        }
        return false;
    };
    return InteractionControllerService;
}());
InteractionControllerService.instance = null;
exports.InteractionControllerService = InteractionControllerService;

//# sourceMappingURL=interaction-controller.service.js.map
