"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var environment_service_1 = require("../environment.service");
var jira_integration_api_1 = require("../jira/jira-integration.api");
var object_util_1 = require("../util/object.util");
var string_util_1 = require("../util/string.util");
var interaction_controller_service_1 = require("./interaction-controller.service");
var RespawnCampingService = (function () {
    function RespawnCampingService() {
        this.objectUtil = new object_util_1.ObjectUtil();
        this.stringUtil = new string_util_1.StringUtil();
        this.jiraApi = new jira_integration_api_1.JiraIntegrationApi();
        this.environment = new environment_service_1.EnvironmentService();
        this.interactionController = new interaction_controller_service_1.InteractionControllerService();
        if (!RespawnCampingService.instance) {
            RespawnCampingService.instance = this;
        }
        return RespawnCampingService.instance;
    }
    RespawnCampingService.prototype.registerRespawnedBug = function (normalizerName, error) {
        return __awaiter(this, void 0, void 0, function () {
            var canInteract, registrable, resultSet, issueKey, issueResultSet, firstStateId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.interactionController.canInteract()];
                    case 1:
                        canInteract = _a.sent();
                        if (!canInteract) {
                            return [2 /*return*/, Promise.resolve()];
                        }
                        registrable = this.createRegistrableError(normalizerName, error);
                        return [4 /*yield*/, this.jiraApi.findIssueByLabel([this.environment.SOFTWARE_IDENTIFIER, registrable.error.id], 1)];
                    case 2:
                        resultSet = _a.sent();
                        issueKey = this.getIssueKeyFromSearch(resultSet);
                        if (!issueKey) return [3 /*break*/, 8];
                        return [4 /*yield*/, this.jiraApi.getIssue(issueKey)];
                    case 3:
                        issueResultSet = _a.sent();
                        return [4 /*yield*/, this.getFirstTransactionId(issueKey)];
                    case 4:
                        firstStateId = _a.sent();
                        if (!firstStateId) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.jiraApi.setIssueTransaction(issueKey, firstStateId)];
                    case 5:
                        _a.sent();
                        if (!this.interactionController.shouldComment(issueResultSet)) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.jiraApi.commentOnIssue(issueKey, this.generateCommentResultSet(registrable))];
                    case 6:
                        _a.sent();
                        return [2 /*return*/, Promise.resolve()];
                    case 7: return [2 /*return*/, Promise.resolve()];
                    case 8: return [4 /*yield*/, this.jiraApi.createIssue(this.generateIssueResultSet(registrable))];
                    case 9:
                        _a.sent();
                        return [2 /*return*/, Promise.resolve()];
                }
            });
        });
    };
    RespawnCampingService.prototype.getFirstTransactionId = function (issueKey) {
        return __awaiter(this, void 0, void 0, function () {
            var firstStateId, issueTransactions, firstIssueState;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firstStateId = this.environment.initialTransactionId;
                        if (!!firstStateId) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.jiraApi.getIssueTransitionHistory(issueKey)];
                    case 1:
                        issueTransactions = _a.sent();
                        firstIssueState = issueTransactions.transitions.shift();
                        firstStateId = firstIssueState && firstIssueState.id || null;
                        return [2 /*return*/, Promise.resolve(firstStateId)];
                    case 2: return [2 /*return*/, Promise.resolve(firstStateId)];
                }
            });
        });
    };
    RespawnCampingService.prototype.generateCommentResultSet = function (toRegister) {
        return {
            body: toRegister.error.title + "\n\n" + toRegister.aditionalInformation
        };
    };
    RespawnCampingService.prototype.generateIssueResultSet = function (toRegister) {
        return {
            fields: {
                summary: toRegister.error.title,
                issuetype: {
                    name: this.environment.bugTypeName || 'Bug'
                },
                description: toRegister.aditionalInformation,
                labels: toRegister.error.labels,
                project: {
                    key: this.environment.defaultProjectKey
                }
            }
        };
    };
    RespawnCampingService.prototype.getIssueKeyFromSearch = function (resultSet) {
        return resultSet.issues && resultSet.issues[0] && resultSet.issues[0].key || null;
    };
    RespawnCampingService.prototype.createRegistrableError = function (normalizerName, error) {
        var _this = this;
        var clonedError = this.objectUtil.clone(error);
        clonedError.id = this.stringUtil.labelfy("id-" + normalizerName + "-" + clonedError.id);
        clonedError.labels.push(this.environment.SOFTWARE_IDENTIFIER);
        clonedError.labels = clonedError.labels.map(function (label) { return _this.stringUtil.labelfy(label); });
        clonedError.labels.push(clonedError.id);
        var aditionalInformation = '' +
            "Environment Information:\n" +
            ("User Agent: " + navigator.userAgent + ";\n") +
            ("Browser size: (" + innerWidth + " x " + innerHeight + ");\n") +
            ("Url: " + location.href + ";\n") +
            ("Time: " + this.getFormattedCurrentDate() + ";\n") +
            '\n' +
            (this.environment.aditionalInformation + "\n") +
            '\n' +
            (error.content + "\n");
        return {
            originName: normalizerName,
            aditionalInformation: aditionalInformation,
            error: clonedError
        };
    };
    RespawnCampingService.prototype.getFormattedCurrentDate = function () {
        var date = new Date();
        var decimalBase = 10;
        var d = date.getDate();
        d = d < decimalBase ? '0' + d : d;
        var m = date.getMonth() + 1;
        m = m < decimalBase ? '0' + m : m;
        var Y = date.getFullYear();
        var H = date.getHours();
        H = H < decimalBase ? '0' + H : H;
        var i = date.getMinutes();
        i = i < decimalBase ? '0' + i : i;
        var s = date.getSeconds();
        s = s < decimalBase ? '0' + s : s;
        return "[" + d + "/" + m + "/" + Y + " " + H + ":" + i + ":" + s + "]";
    };
    return RespawnCampingService;
}());
RespawnCampingService.instance = null;
exports.RespawnCampingService = RespawnCampingService;

//# sourceMappingURL=respawn-camping.service.js.map
