"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var StringUtil = (function () {
    function StringUtil() {
        this.MAX_LABEL_SIZE = 45;
        this.NOT_ALPHANUMERIC_CHAR = /[^a-z0-9\s\-]/ig;
        this.ACCENT_A = /[áàãâ]/ig;
        this.ACCENT_E = /[éèê]/ig;
        this.ACCENT_I = /[íì]/ig;
        this.ACCENT_O = /[óõòô]/ig;
        this.ACCENT_U = /[úùü]/ig;
        if (!StringUtil.instance) {
            StringUtil.instance = this;
        }
        return StringUtil.instance;
    }
    StringUtil.prototype.labelfy = function (label) {
        return label
            .trim()
            .replace(this.ACCENT_A, 'a')
            .replace(this.ACCENT_E, 'e')
            .replace(this.ACCENT_I, 'i')
            .replace(this.ACCENT_O, 'o')
            .replace(this.ACCENT_U, 'u')
            .replace(this.NOT_ALPHANUMERIC_CHAR, '')
            .replace(/\s+/g, '-')
            .replace(/\[-]+/g, '-')
            .toLowerCase()
            .substr(0, this.MAX_LABEL_SIZE);
    };
    return StringUtil;
}());
StringUtil.instance = null;
exports.StringUtil = StringUtil;

//# sourceMappingURL=string.util.js.map
